# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorageSync::Mgmt::V2018_04_02
  module Models
    #
    # The parameters used when creating a storage sync service.
    #
    class RegisteredServerCreateParameters

      include MsRestAzure

      # @return [String] Required. Gets or sets the location of the resource.
      # This will be one of the supported and registered Azure Geo Regions
      # (e.g. West US, East US, Southeast Asia, etc.). The geo region of a
      # resource cannot be changed once it is created, but if an identical geo
      # region is specified on update, the request will succeed.
      attr_accessor :location

      # @return [Hash{String => String}] Gets or sets a list of key value pairs
      # that describe the resource. These tags can be used for viewing and
      # grouping this resource (across resource groups). A maximum of 15 tags
      # can be provided for a resource. Each tag must have a key with a length
      # no greater than 128 characters and a value with a length no greater
      # than 256 characters.
      attr_accessor :tags

      # @return [String] Registered Server Certificate
      attr_accessor :server_certificate

      # @return [String] Registered Server Agent Version
      attr_accessor :agent_version

      # @return [String] Registered Server OS Version
      attr_accessor :server_osversion

      # @return [String] Registered Server last heart beat
      attr_accessor :last_heart_beat

      # @return [String] Registered Server serverRole
      attr_accessor :server_role

      # @return [String] Registered Server clusterId
      attr_accessor :cluster_id

      # @return [String] Registered Server clusterName
      attr_accessor :cluster_name

      # @return [String] Registered Server serverId
      attr_accessor :server_id

      # @return [String] Friendly Name
      attr_accessor :friendly_name


      #
      # Mapper for RegisteredServerCreateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RegisteredServerCreateParameters',
          type: {
            name: 'Composite',
            class_name: 'RegisteredServerCreateParameters',
            model_properties: {
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              server_certificate: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serverCertificate',
                type: {
                  name: 'String'
                }
              },
              agent_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.agentVersion',
                type: {
                  name: 'String'
                }
              },
              server_osversion: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serverOSVersion',
                type: {
                  name: 'String'
                }
              },
              last_heart_beat: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastHeartBeat',
                type: {
                  name: 'String'
                }
              },
              server_role: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serverRole',
                type: {
                  name: 'String'
                }
              },
              cluster_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.clusterId',
                type: {
                  name: 'String'
                }
              },
              cluster_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.clusterName',
                type: {
                  name: 'String'
                }
              },
              server_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serverId',
                type: {
                  name: 'String'
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
