# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::StorageSync::Mgmt::V2019_03_01
  module Models
    #
    # Parameters for updating an Server Endpoint.
    #
    class ServerEndpointUpdateParameters

      include MsRestAzure

      # @return [Enum] Cloud Tiering. Possible values include: 'on', 'off'
      attr_accessor :cloud_tiering

      # @return [Integer] Level of free space to be maintained by Cloud Tiering
      # if it is enabled.
      attr_accessor :volume_free_space_percent

      # @return [Integer] Tier files older than days.
      attr_accessor :tier_files_older_than_days

      # @return [Enum] Offline data transfer. Possible values include: 'on',
      # 'off'
      attr_accessor :offline_data_transfer

      # @return [String] Offline data transfer share name
      attr_accessor :offline_data_transfer_share_name


      #
      # Mapper for ServerEndpointUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ServerEndpointUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'ServerEndpointUpdateParameters',
            model_properties: {
              cloud_tiering: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.cloudTiering',
                type: {
                  name: 'String'
                }
              },
              volume_free_space_percent: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.volumeFreeSpacePercent',
                constraints: {
                  InclusiveMaximum: 100,
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              },
              tier_files_older_than_days: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.tierFilesOlderThanDays',
                constraints: {
                  InclusiveMaximum: 2147483647,
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              },
              offline_data_transfer: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.offlineDataTransfer',
                type: {
                  name: 'String'
                }
              },
              offline_data_transfer_share_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.offlineDataTransferShareName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
